unit About;

interface

uses
  Database, EnterRegister,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ShellAPI, StdCtrls, ExtCtrls, Buttons, Menus, Printers, GIFImage, fcLabel;

type
  TFormAbout = class(TForm)
    ImageIcon: TImage;
    Bevel1: TBevel;
    BtnDone: TBitBtn;
    PanelRules: TPanel;
    MemoLicense: TMemo;
    MainMenu: TMainMenu;
    Ctrls1: TMenuItem;
    MenuExit: TMenuItem;
    LabelVersion: TLabel;
    Label4: TLabel;
    LabelLink2: TLabel;  
    LabelLink0: TLabel;
    Label1: TLabel;
    Label17: TLabel;
    Label5: TLabel;
    Bevel2: TBevel;
    PanelGA: TPanel;
    ImageLogo: TImage;
    DialogPrint: TPrintDialog;
    BtnEnterRegistry: TBitBtn;
    MemoRegistration: TMemo;
    Label2: TLabel;
    LabelLink3: TLabel;
    ImageRegister: TGIFImage;
    LabelRegister: TfcLabel;
    procedure BtnDoneClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure LabelLink0Click(Sender: TObject);
    procedure BtnEnterRegistryClick(Sender: TObject);
    procedure LabelVersionDblClick(Sender: TObject);
    procedure MemoRegistrationClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    RefreshRegistry: boolean;
  end;

var
  FormAbout: TFormAbout;

implementation

{$R *.DFM}

procedure TFormAbout.FormCreate(Sender: TObject);
begin
  RefreshRegistry:=false;
  ImageIcon.picture.icon.assign(application.icon);
  LabelLink0.cursor:=Datawell.handpoint;
  LabelLink2.cursor:=Datawell.handpoint;
  LabelLink3.cursor:=Datawell.handpoint;
  ImageIcon.cursor:=Datawell.handpoint;
  ImageLogo.cursor:=Datawell.handpoint;
  LabelRegister.cursor:=Datawell.handpoint;
  ImageRegister.cursor:=Datawell.handpoint;
end;
                         
procedure TFormAbout.BtnDoneClick(Sender: TObject);
begin
  close;
end;                          

procedure TFormAbout.LabelLink0Click(Sender: TObject);
var link: string;
begin
  link:='';
  case TLabel(sender).tag of
    0: link:='http://www.'+Datawell.homesite+'.com';
    2: link:='http://www.'+Datawell.homesite+'.com/reframe.php?target=how_to_mud.html';
    3: link:='http://www.'+Datawell.homesite+'.com/reframe.php?target=troubleshooting.html';
    5: link:='http://www.'+Datawell.homesite+'.com/reframe.php?target=cgi-bin/ga_pages.pl?register';
  end;
  Datawell.EXE(link,'','c:\',SW_SHOW);
end;

procedure TFormAbout.BtnEnterRegistryClick(Sender: TObject);
var form: TFormEnterRegister;
begin
  messagedlg('No need, as you are registered',mtinformation,[mbok],0);
end;

procedure TFormAbout.LabelVersionDblClick(Sender: TObject);
begin
  messagedlg(Datawell.version2,mtinformation,[mbok],0);
end;

procedure TFormAbout.MemoRegistrationClick(Sender: TObject);
begin
  BtnDone.setfocus;
end;

end.
