unit AskRegister;

interface

uses
  Database, EnterRegister,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, fcLabel;

type
  TFormAskRegister = class(TForm)
    TimerDelay: TTimer;
    PanelMain: TPanel;
    BtnOK: TBitBtn;
    BtnRegister: TBitBtn;
    LabelMessage: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    BtnEnterRegister: TBitBtn;
    LabelDay: TfcLabel;
    Image1: TImage;
    procedure BtnRegisterClick(Sender: TObject);
    procedure BtnOKClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TimerDelayTimer(Sender: TObject);
    procedure BtnEnterRegisterClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    linked: boolean;
    RefreshRegistry: boolean;
  end;

var
  FormAskRegister: TFormAskRegister;

implementation

{$R *.DFM}

procedure TFormAskRegister.FormCreate(Sender: TObject);
begin
  linked:=false;
end;

procedure TFormAskRegister.BtnRegisterClick(Sender: TObject);
begin
  linked:=true;
  close;
end;

procedure TFormAskRegister.BtnOKClick(Sender: TObject);
begin
  close;
end;

procedure TFormAskRegister.TimerDelayTimer(Sender: TObject);
begin
  BtnRegister.show;
  BtnEnterRegister.show;
  BtnOK.show;
  height:=265;
end;

procedure TFormAskRegister.BtnEnterRegisterClick(Sender: TObject);
var form: TFormEnterRegister;
begin
  form:=TFormEnterRegister.create(self);
  form.notfromabout:=true;
  form.showmodal;
  RefreshRegistry:=form.RefreshRegistry;
  form.free;
  if RefreshRegistry then begin
    BtnEnterRegister.hide;
    BtnOK.caption:='Verify Registration';
    BtnOK.setfocus;
  end;
end;

end.
