unit Game;

interface

uses
  Database,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls, DB, Wwdatsrc, Grids, Wwdbigrd, Wwdbgrid,
  Menus, ExtCtrls, jpeg, fcLabel;

type
  TFormGame = class(TForm)
    sc: TImage;
    sd: TImage;
    sh: TImage;
    ss: TImage;
    Messages: TMemo;
    c35: TImage;
    c34: TImage;
    c33: TImage;
    c32: TImage;
    c31: TImage;
    c25: TImage;
    c24: TImage;
    c23: TImage;
    c22: TImage;
    c21: TImage;
    c41: TImage;
    c42: TImage;
    c43: TImage;
    c44: TImage;
    c45: TImage;
    cp2: TImage;
    cp3: TImage;
    cp1: TImage;
    cp4: TImage;
    c1: TImage;
    c2: TImage;
    c3: TImage;
    c4: TImage;
    c5: TImage;
    t1: TShape;
    c6: TImage;
    cn1: TfcLabel;
    cn2: TfcLabel;
    cn3: TfcLabel;
    cn4: TfcLabel;
    cn5: TfcLabel;
    cn6: TfcLabel;
    cpn2: TfcLabel;
    cpn3: TfcLabel;
    cpn4: TfcLabel;
    cpn1: TfcLabel;
    t2: TShape;
    t3: TShape;
    t4: TShape;
    t5: TShape;
    t6: TShape;
    tp1: TShape;
    tp4: TShape;
    tp3: TShape;
    tp2: TShape;
    ShapeTrump: TShape;
    c46: TImage;
    c26: TImage;
    c36: TImage;
    player3: TfcLabel;
    player2: TfcLabel;
    player4: TfcLabel;
    fcLabel2: TfcLabel;
    fcLabel6: TfcLabel;
    player1: TfcLabel;
    tricksy: TfcLabel;
    trickst: TfcLabel;
    fcLabel1: TfcLabel;
    fcLabel3: TfcLabel;
    scorey: TfcLabel;
    scoret: TfcLabel;
    fcLabel4: TfcLabel;
    fcLabel5: TfcLabel;
    Turn3: TImage;
    Turn4: TImage;
    Turn2: TImage;
    Turn1: TImage;
    Alone: TfcLabel;
    Panel1: TPanel;
    Edit1: TEdit;
    waiting: TfcLabel;
    fcLabel8: TfcLabel;
    Bevel1: TBevel;
    called3: TShape;
    called1: TShape;
    called2: TShape;
    called4: TShape;
    high2: TShape;
    high3: TShape;
    high1: TShape;
    high4: TShape;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    whoami, creatorname, trump: string;
    creator: integer;
    procedure WMGetMinMaxInfo(var MSG: Tmessage); message WM_GETMINMAXINFO;
    procedure DrawCard(which: integer; num, suit: string);
    procedure SetTrump(suit: string);
    procedure ClearTable;
  public
    procedure ProcessCode(s1, data: string);
    { Public declarations }
  end;

var
  FormGame: TFormGame;

implementation

uses Main;

{$R *.DFM}

procedure TFormGame.FormCreate(Sender: TObject);
begin
  whoami:='';
  creatorname:='';
  trump:='';
  creator:=0;
end;

procedure TFormGame.WMGetMinMaxInfo(var MSG: Tmessage);
begin
  inherited;
  with PMinMaxInfo(MSG.lparam)^ do begin
    with ptMinTrackSize do begin
      X := 250;
      Y := 200;
    end;
    with ptMaxTrackSize do begin
      X := 9999;
      Y := 9999;
    end;
  end;
end;

procedure TFormGame.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  FormMain.UnloadScreen(13);
end;

procedure TFormGame.ProcessCode(s1, data: string);
var
  work, p1, p2, p3, p4, dealer, turn, tricks, called, upcard, cards, inhand, lead: string;
  r1, r2, r3: string;
  x, p, x1, x2, x3, x4, y1, y2, y3, y4: integer;
begin
  if s1 = 'A' then begin
    c1.hide; c2.hide; c3.hide; c4.hide; c5.hide; c6.hide;
    cn1.hide; cn2.hide; cn3.hide; cn4.hide; cn5.hide; cn6.hide;
    t1.hide; t2.hide; t3.hide; t4.hide; t5.hide; t6.hide;
    x:=1;
    while length(data) > 1 do begin
      DrawCard(x,copy(data,1,1),copy(data,2,1));
      delete(data,1,2);
      inc(x);
    end;
  end
  else if s1 = 'B' then begin
{
B-Tensor~T-Nick~0,0,0,0~Waiting on T-Nick to order it or pass~

GEB
1) Who am i
2) Lead
3) Whose turn
4) Creator's tricks, Player 1 tricks, player 2, player 3
5) "Waiting on such and such"
6) Cards on the table, ! leading the high card, from the LEAD's perspective
7) # of cards in hands, starting from creator
}
    p:=pos('~',data);
    delete(data,1,p);
    p:=pos('~',data);
    lead:=copy(data,1,p-1);
    delete(data,1,p);
    p:=pos('~',data);
    turn:=copy(data,1,p-1);
    turn1.visible:=(turn = player1.hint);
    turn2.visible:=(turn = player2.hint);
    turn3.visible:=(turn = player3.hint);
    turn4.visible:=(turn = player4.hint);
    delete(data,1,p);
    p:=pos('~',data);
    tricks:=copy(data,1,p-1);
    y1:=Datawell.toint(copy(tricks,1,1));
    y2:=Datawell.toint(copy(tricks,3,1));
    y3:=Datawell.toint(copy(tricks,5,1));
    y4:=Datawell.toint(copy(tricks,7,1));
    if (player1.hint = creatorname) or (player3.hint = creatorname) then begin
      tricksy.caption:=inttostr(y1+y3);
      trickst.caption:=inttostr(y2+y4);
    end
    else begin
      trickst.caption:=inttostr(y1+y3);
      tricksy.caption:=inttostr(y2+y4);
    end;
    delete(data,1,p);
    p:=pos('~',data);
    waiting.caption:=copy(data,1,p-1);
    delete(data,1,p);
    p:=pos('~',data);
    cards:=copy(data,1,p-1);
    delete(data,1,p);
    if cards <> '' then begin
      ClearTable;
      cards:=cards+',';
      p:=pos(',',cards);
      r1:=copy(cards,1,p-1);
      delete(cards,1,p);
      p:=pos(',',cards);
      r2:=copy(cards,1,p-1);
      delete(cards,1,p);
      p:=pos(',',cards);
      r3:=copy(cards,1,p-1);
      if player1.hint = lead then begin
        high1.visible:=copy(r1,1,1) = '!';
        if high1.visible then delete(r1,1,1);
        DrawCard(11,copy(r1,1,1),copy(r1,2,1));
        if r2 <> '' then begin
          high2.visible:=copy(r2,1,1) = '!';
          if high2.visible then delete(r2,1,1);
          DrawCard(12,copy(r2,1,1),copy(r2,2,1));
        end;
        if r3 <> '' then begin
          high3.visible:=copy(r3,1,1) = '!';
          if high3.visible then delete(r3,1,1);
          DrawCard(13,copy(r3,1,1),copy(r3,2,1));
        end;
      end
      else if player2.hint = lead then begin
        high2.visible:=copy(r1,1,1) = '!';
        if high2.visible then delete(r1,1,1);
        DrawCard(12,copy(r1,1,1),copy(r1,2,1));
        if r2 <> '' then begin
          high3.visible:=copy(r2,1,1) = '!';
          if high3.visible then delete(r2,1,1);
          DrawCard(13,copy(r2,1,1),copy(r2,2,1));
        end;
        if r3 <> '' then begin
          high4.visible:=copy(r3,1,1) = '!';
          if high4.visible then delete(r3,1,1);
          DrawCard(14,copy(r3,1,1),copy(r3,2,1));
        end;
      end
      else if player3.hint = lead then begin
        high3.visible:=copy(r1,1,1) = '!';
        if high3.visible then delete(r1,1,1);
        DrawCard(13,copy(r1,1,1),copy(r1,2,1));
        if r2 <> '' then begin
          high4.visible:=copy(r2,1,1) = '!';
          if high4.visible then delete(r2,1,1);
          DrawCard(14,copy(r2,1,1),copy(r2,2,1));
        end;
        if r3 <> '' then begin
          high1.visible:=copy(r3,1,1) = '!';
          if high1.visible then delete(r3,1,1);
          DrawCard(11,copy(r3,1,1),copy(r3,2,1));
        end;
      end
      else if player4.hint = lead then begin
        high4.visible:=copy(r1,1,1) = '!';
        if high4.visible then delete(r1,1,1);
        DrawCard(14,copy(r1,1,1),copy(r1,2,1));
        if r2 <> '' then begin
          high1.visible:=copy(r2,1,1) = '!';
          if high1.visible then delete(r2,1,1);
          DrawCard(11,copy(r2,1,1),copy(r2,2,1));
        end;
        if r3 <> '' then begin
          high2.visible:=copy(r3,1,1) = '!';
          if high2.visible then delete(r3,1,1);
          DrawCard(12,copy(r3,1,1),copy(r3,2,1));
        end;
      end;
    end;
    inhand:=data;
    x1:=Datawell.toint(copy(inhand,1,1));
    x2:=Datawell.toint(copy(inhand,3,1));
    x3:=Datawell.toint(copy(inhand,5,1));
    x4:=Datawell.toint(copy(inhand,7,1));
    if player1.hint = creatorname then begin
      c21.visible:=x2 > 0;
      c22.visible:=x2 > 1;
      c23.visible:=x2 > 2;
      c24.visible:=x2 > 3;
      c25.visible:=x2 > 4;
      c26.visible:=x2 > 5;
      c31.visible:=x3 > 0;
      c32.visible:=x3 > 1;
      c33.visible:=x3 > 2;
      c34.visible:=x3 > 3;
      c35.visible:=x3 > 4;
      c36.visible:=x3 > 5;
      c41.visible:=x4 > 0;
      c42.visible:=x4 > 1;
      c43.visible:=x4 > 2;
      c44.visible:=x4 > 3;
      c45.visible:=x4 > 4;
      c46.visible:=x4 > 5;
    end
    else if player2.hint = creatorname then begin
      c21.visible:=x1 > 0;
      c22.visible:=x1 > 1;
      c23.visible:=x1 > 2;
      c24.visible:=x1 > 3;
      c25.visible:=x1 > 4;
      c26.visible:=x1 > 5;
      c31.visible:=x2 > 0;
      c32.visible:=x2 > 1;
      c33.visible:=x2 > 2;
      c34.visible:=x2 > 3;
      c35.visible:=x2 > 4;
      c36.visible:=x2 > 5;
      c41.visible:=x3 > 0;
      c42.visible:=x3 > 1;
      c43.visible:=x3 > 2;
      c44.visible:=x3 > 3;
      c45.visible:=x3 > 4;
      c46.visible:=x3 > 5;
    end
    else if player3.hint = creatorname then begin
      c31.visible:=x1 > 0;
      c32.visible:=x1 > 1;
      c33.visible:=x1 > 2;
      c34.visible:=x1 > 3;
      c35.visible:=x1 > 4;
      c36.visible:=x1 > 5;
      c41.visible:=x2 > 0;
      c42.visible:=x2 > 1;
      c43.visible:=x2 > 2;
      c44.visible:=x2 > 3;
      c45.visible:=x2 > 4;
      c46.visible:=x2 > 5;
      c21.visible:=x4 > 0;
      c22.visible:=x4 > 1;
      c23.visible:=x4 > 2;
      c24.visible:=x4 > 3;
      c25.visible:=x4 > 4;
      c26.visible:=x4 > 5;
    end
    else if player4.hint = creatorname then begin
      c41.visible:=x1 > 0;
      c42.visible:=x1 > 1;
      c43.visible:=x1 > 2;
      c44.visible:=x1 > 3;
      c45.visible:=x1 > 4;
      c46.visible:=x1 > 5;
      c21.visible:=x3 > 0;
      c22.visible:=x3 > 1;
      c23.visible:=x3 > 2;
      c24.visible:=x3 > 3;
      c25.visible:=x3 > 4;
      c26.visible:=x3 > 5;
      c31.visible:=x4 > 0;
      c32.visible:=x4 > 1;
      c33.visible:=x4 > 2;
      c34.visible:=x4 > 3;
      c35.visible:=x4 > 4;
      c36.visible:=x4 > 5;
    end;
  end
  else if s1 = 'C' then begin
{
GEC
1) Who am I?
2) Dealer
3) Who called it
4) Did they go alone "Y" or "N"
5) The score, comma separated, creator's score first
6) Trump, as a single character, N if no trump yet
7) Flipped up card, as other cards, empty string if no card up
}
    p:=pos('~',data);
    delete(data,1,p);
    p:=pos('~',data);
    dealer:=copy(data,1,p-1);
    delete(data,1,p);
    p:=pos('~',data);
    called:=copy(data,1,p-1);
    called1.visible:=called = player1.hint;
    called2.visible:=called = player2.hint;
    called3.visible:=called = player3.hint;
    called4.visible:=called = player4.hint;
    if called1.visible then begin
      player1.color:=clblack;
      player1.font.color:=clwhite;
    end
    else begin
      player1.color:=clwhite;
      player1.font.color:=clblack;
    end;
    if called2.visible then begin
      player2.color:=clblack;
      player2.font.color:=clwhite;
    end
    else begin
      player2.color:=clwhite;
      player2.font.color:=clblack;
    end;
    if called3.visible then begin
      player3.color:=clblack;
      player3.font.color:=clwhite;
    end
    else begin
      player3.color:=clwhite;
      player3.font.color:=clblack;
    end;
    if called4.visible then begin
      player4.color:=clblack;
      player4.font.color:=clwhite;
    end
    else begin
      player4.color:=clwhite;
      player4.font.color:=clblack;
    end;
    delete(data,1,p);
    Alone.visible:=copy(data,1,1) = 'Y';
    delete(data,1,2);
    p:=pos('~',data);
    work:=copy(data,1,p-1);
    delete(data,1,p);
    p:=pos(',',work);
    if (creator = 1) or (creator = 3) then begin
      scorey.caption:=copy(work,1,p-1);
      scoret.caption:=copy(work,p+1,9999);
    end
    else begin
      scoret.caption:=copy(work,1,p-1);
      scorey.caption:=copy(work,p+1,9999);
    end;
    p:=pos('~',data);
    work:=copy(data,1,p-1);
    delete(data,1,p);
    if work = 'N' then begin
      SetTrump(copy(data,2,1));
      ShapeTrump.pen.color:=clteal;
    end
    else SetTrump(work);
    upcard:=data;
    ClearTable;
    if upcard <> '' then begin
      player1.caption:=player1.hint;
      player2.caption:=player2.hint;
      player3.caption:=player3.hint;
      player4.caption:=player4.hint;
      player1.show; player2.show; player3.show; player4.show;
      if dealer = player1.hint then begin
        player1.caption:=player1.hint+' (dealer)';
        if upcard <> '' then begin
          DrawCard(11,copy(upcard,1,1),copy(upcard,2,1));
          tp1.Pen.color:=clteal;
        end;
      end
      else if dealer = player2.hint then begin
        player2.caption:=player2.hint+' (dealer)';
        if upcard <> '' then begin
          DrawCard(12,copy(upcard,1,1),copy(upcard,2,1));
          tp2.Pen.color:=clteal;
        end;
      end
      else if dealer = player3.hint then begin
        player3.caption:=player3.hint+' (dealer)';
        if upcard <> '' then begin
          DrawCard(13,copy(upcard,1,1),copy(upcard,2,1));
          tp3.Pen.color:=clteal;
        end;
      end
      else begin
        player4.caption:=player4.hint+' (dealer)';
        if upcard <> '' then begin
          DrawCard(14,copy(upcard,1,1),copy(upcard,2,1));
          tp4.Pen.color:=clteal;
        end;
      end;
    end;
  end
  else if s1 = 'D' then begin
    //nothing
  end
  else if s1 = 'E' then Messages.lines.add(data)
  else if s1 = 'F' then begin
    p:=pos('~',data);
    whoami:=copy(data,1,p-1);
    delete(data,1,p);
    p:=pos('~',data);
    caption:='Game: '+copy(data,1,p-1);
    delete(data,1,p);
    p:=pos('~',data);
    creatorname:=copy(data,1,p-1);
    if whoami = creatorname then creator:=1;
    delete(data,1,p);
    p:=pos('~',data);
    work:=copy(data,1,p-1); //Team Names
    delete(data,1,p);
    p:=pos('~',data);
    work:=copy(data,1,p-1); //Players
    delete(data,1,p);
    p:=pos(',',work);
    p1:=copy(work,1,p-1); //Player1
    delete(work,1,p);
    p:=pos(',',work);
    p2:=copy(work,1,p-1); //Player2
    if p2 = creatorname then creator:=2;
    delete(work,1,p);
    p:=pos(',',work);
    p3:=copy(work,1,p-1); //Player3
    if p3 = creatorname then creator:=3;
    delete(work,1,p);
    p4:=work; //Player4
    if p4 = creatorname then creator:=4;
    if creator = 1 then begin
      player1.caption:=p1; player2.caption:=p2; player3.caption:=p3; player4.caption:=p4;
    end
    else if creator = 2 then begin
      player2.caption:=p1; player3.caption:=p2; player4.caption:=p3; player1.caption:=p4;
    end
    else if creator = 3 then begin
      player3.caption:=p1; player4.caption:=p2; player1.caption:=p3; player2.caption:=p4;
    end
    else begin
      player4.caption:=p1; player1.caption:=p2; player2.caption:=p3; player3.caption:=p4;
    end;
    player1.hint:=player1.caption;
    player2.hint:=player2.caption;
    player3.hint:=player3.caption;
    player4.hint:=player4.caption;
    caption:=caption+' ['+data+']';
{
F-tensor~tensor~tensor~spurm,piehole~tensor,T-Dan,T-Toney,T-Hector~Last Trick Not Auto,*Training*,

GEF
1) Who am I
2) Game Name
3) Creator
4) Team names (creator's team, other team)
5) Players, starting with creator
6) Options
}
  end
  else if s1 = 'G' then begin
    Messages.lines.add(data)
  end
  else if s1 = 'H' then begin
    ClearTable;
    Messages.lines.add(data)
  end
  else Messages.lines.add(s1+'-'+data);
end;

procedure TFormGame.SetTrump(suit: string);
begin
  sh.hide; sd.hide; sc.hide; ss.hide;
  trump:=suit;
  if trump = 'H' then sh.show
  else if trump = 'D' then sd.show
  else if trump = 'C' then sc.show
  else if trump = 'S' then ss.show;
  shapetrump.Pen.color:=clfuchsia;
end;

procedure TFormGame.DrawCard(which: integer; num, suit: string);
var
  can1, can2: TCanvas;
  lab: TfcLabel;
  shap: TShape;
begin
  case which of
    1: begin can1:=c1.canvas; lab:=cn1; c1.show; shap:=t1; end;
    2: begin can1:=c2.canvas; lab:=cn2; c2.show; shap:=t2; end;
    3: begin can1:=c3.canvas; lab:=cn3; c3.show; shap:=t3; end;
    4: begin can1:=c4.canvas; lab:=cn4; c4.show; shap:=t4; end;
    5: begin can1:=c5.canvas; lab:=cn5; c5.show; shap:=t5; end;
    6: begin can1:=c6.canvas; lab:=cn6; c6.show; shap:=t6; end;
    11: begin can1:=cp1.canvas; lab:=cpn1; cp1.show; shap:=tp1; end;
    12: begin can1:=cp2.canvas; lab:=cpn2; cp2.show; shap:=tp2; end;
    13: begin can1:=cp3.canvas; lab:=cpn3; cp3.show; shap:=tp3; end;
    14: begin can1:=cp4.canvas; lab:=cpn4; cp4.show; shap:=tp4; end;
  end;
  if suit = 'H' then can2:=sh.canvas
  else if suit = 'D' then can2:=sd.canvas
  else if suit = 'C' then can2:=sc.canvas
  else if suit = 'S' then can2:=ss.canvas;
  if suit = trump then begin
    shap.pen.color:=clfuchsia;
    shap.show;
  end;
  if num = 'J' then begin
    if (suit = 'H') and (trump = 'D') then shap.show
    else if (suit = 'D') and (trump = 'H') then shap.show
    else if (suit = 'C') and (trump = 'S') then shap.show
    else if (suit = 'S') and (trump = 'C') then shap.show
  end;
  if num = '0' then num:='10';
  lab.caption:=num;
  can1.copymode:=cmsrccopy;
  can1.CopyRect(rect(9,28,31,52),can2,rect(0,0,22,24));
  lab.show;
end;

procedure TFormGame.ClearTable;
begin
  cp1.hide; cp2.hide; cp3.hide; cp4.hide;
  tp1.hide; tp2.hide; tp3.hide; tp4.hide;
  cpn1.hide; cpn2.hide; cpn3.hide; cpn4.hide;
  high1.hide; high2.hide; high3.hide; high4.hide;
end;

end.
