unit Macros;

interface

uses
  Database, Functions, VarGrabber, AM,
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, Menus, Grids, Wwdbigrd, Wwdbgrid,
  ExtCtrls, DB, DBTables, Wwdatsrc, Wwtable, Mask, Wwdbedit, Wwdotdot,
  Wwdbcomb, ComCtrls, wwdblook;

type
  TFormMacros = class(TForm)
    GridMacro: TwwDBGrid;
    MainMenu1: TMainMenu;
    MenuBasics: TMenuItem;
    F21: TMenuItem;
    F31: TMenuItem;
    F41: TMenuItem;
    F51: TMenuItem;
    F61: TMenuItem;
    F71: TMenuItem;
    F81: TMenuItem;
    F91: TMenuItem;
    F101: TMenuItem;
    F111: TMenuItem;
    F121: TMenuItem;
    MenuAlts: TMenuItem;
    AltF11: TMenuItem;
    AltF21: TMenuItem;
    AltF31: TMenuItem;
    AltF41: TMenuItem;
    AltF51: TMenuItem;
    AltF61: TMenuItem;
    AltF71: TMenuItem;
    AltF81: TMenuItem;
    AltF91: TMenuItem;
    AltF101: TMenuItem;
    AltF111: TMenuItem;
    AltF121: TMenuItem;
    MenuShifts: TMenuItem;
    ShiftF11: TMenuItem;
    ShiftF21: TMenuItem;
    ShiftF31: TMenuItem;
    ShiftF41: TMenuItem;
    ShiftF51: TMenuItem;
    ShiftF61: TMenuItem;
    ShiftF71: TMenuItem;
    ShiftF81: TMenuItem;
    ShiftF91: TMenuItem;
    ShiftF101: TMenuItem;
    ShiftF111: TMenuItem;
    ShiftF121: TMenuItem;
    MenuCtrls: TMenuItem;
    CtrlF11: TMenuItem;
    CtrlF21: TMenuItem;
    CtrlF31: TMenuItem;
    CtrlF41: TMenuItem;
    CtrlF51: TMenuItem;
    CtrlF61: TMenuItem;
    CtrlF71: TMenuItem;
    CtrlF81: TMenuItem;
    CtrlF91: TMenuItem;
    CtrlF101: TMenuItem;
    CtrlF111: TMenuItem;
    CtrlF121: TMenuItem;
    DSMacros: TwwDataSource;
    MenuHelp: TMenuItem;
    PanelFKeys: TPanel;
    BtnF1: TBitBtn;
    a1: TBitBtn;
    s1: TBitBtn;
    c1: TBitBtn;
    c2: TBitBtn;
    s2: TBitBtn;
    a2: TBitBtn;
    f2: TBitBtn;
    f3: TBitBtn;
    a3: TBitBtn;
    s3: TBitBtn;
    c3: TBitBtn;
    c4: TBitBtn;
    s4: TBitBtn;
    a4: TBitBtn;
    f4: TBitBtn;
    f5: TBitBtn;
    a5: TBitBtn;
    s5: TBitBtn;
    c5: TBitBtn;
    c6: TBitBtn;
    s6: TBitBtn;
    a6: TBitBtn;
    f6: TBitBtn;
    f7: TBitBtn;
    a7: TBitBtn;
    s7: TBitBtn;
    c7: TBitBtn;
    c8: TBitBtn;
    s8: TBitBtn;
    a8: TBitBtn;
    f8: TBitBtn;
    f9: TBitBtn;
    a9: TBitBtn;
    s9: TBitBtn;
    c9: TBitBtn;
    c10: TBitBtn;
    s10: TBitBtn;
    a10: TBitBtn;
    f10: TBitBtn;
    f11: TBitBtn;
    a11: TBitBtn;
    s11: TBitBtn;
    c11: TBitBtn;
    c12: TBitBtn;
    a12: TBitBtn;
    s12: TBitBtn;
    f12: TBitBtn;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    PanelSpecialMacros: TPanel;
    Bevel10: TBevel;
    Bevel11: TBevel;
    Bevel6: TBevel;
    LabelLinkdead: TLabel;
    LabelLogin: TLabel;
    LabelPanic: TLabel;
    PanelNumpad: TPanel;
    n1: TBitBtn;
    n2: TBitBtn;
    n3: TBitBtn;
    n4: TBitBtn;
    n5: TBitBtn;
    n6: TBitBtn;
    n7: TBitBtn;
    n8: TBitBtn;
    n9: TBitBtn;
    n0: TBitBtn;
    nd: TBitBtn;
    nf: TBitBtn;
    nm: TBitBtn;
    ns: TBitBtn;
    na: TBitBtn;
    ImagePointer: TImage;
    TimerPointer: TTimer;
    Bevel1: TBevel;
    LabelPanic2: TLabel;
    BtnLogin: TBitBtn;
    BtnPanic: TBitBtn;
    BtnUnpanic: TBitBtn;
    BtnClearLogin: TBitBtn;
    BtnClearPanic: TBitBtn;
    BtnClearUnpanic: TBitBtn;
    Panel1: TPanel;
    Status: TLabel;
    BtnDone: TBitBtn;
    BtnHelp: TBitBtn;
    Bevel2: TBevel;
    Label1: TLabel;
    LabelLines: TLabel;
    Bevel3: TBevel;
    BtnClear: TBitBtn;
    BtnFunctions: TBitBtn;
    Script: TMemo;
    BtnVar: TBitBtn;
    BtnUndo: TBitBtn;
    CtrlF1: TMenuItem;
    CtrlR1: TMenuItem;
    EditCopy: TEdit;
    CtrlZ1: TMenuItem;
    Esc1: TMenuItem;
    BtnAM: TBitBtn;
    CtrlA1: TMenuItem;
    procedure BtnDoneClick(Sender: TObject);
    procedure DSMacrosDataChange(Sender: TObject; Field: TField);
    procedure MacroKeyMasterClick(Sender: TObject);
    procedure GridMacroDblClick(Sender: TObject);
    procedure MacroMasterClick(Sender: TObject);
    procedure GridMacroKeyPress(Sender: TObject; var Key: Char);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure BtnHelpClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure GridMacroCalcCellColors(Sender: TObject; Field: TField;
      State: TGridDrawState; highlight: Boolean; AFont: TFont;
      ABrush: TBrush);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure TimerPointerTimer(Sender: TObject);
    procedure BtnLoginClick(Sender: TObject);
    procedure BtnClearLoginClick(Sender: TObject);
    procedure BtnUndoClick(Sender: TObject);
    procedure BtnFunctionsClick(Sender: TObject);
    procedure BtnVarClick(Sender: TObject);
    procedure BtnClearClick(Sender: TObject);
    procedure ScriptChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure GridMacroEnter(Sender: TObject);
    procedure BtnAMClick(Sender: TObject);
  private
    { Private declarations }
    procedure UpdateLabels;
    procedure UpdateButtons;
    procedure UpdatePointer;
    procedure CheckSave;
    function CountCommands(mac: string): integer;
  public
    { Public declarations }
  end;

var
  FormMacros: TFormMacros;
  bypass: boolean;

implementation

{$R *.DFM}

procedure TFormMacros.MacroKeyMasterClick(Sender: TObject);
begin
  CheckSave;
  UpdateButtons;
  GridMacro.hide;
  with Datawell.TableMacros do begin
    first;
    while not EOF do begin
      if TBitBtn(sender).hint = Datawell.TableMacros.fieldbyname('Macro').asstring then break;
      next;
    end;
  end;
  GridMacro.show;
  DSMacrosDataChange(Sender,nil);
  Script.setfocus;
  TimerPointer.enabled:=true;
end;

procedure TFormMacros.GridMacroDblClick(Sender: TObject);
begin
  Script.setfocus;
end;

procedure TFormMacros.MacroMasterClick(Sender: TObject);
var didfind: boolean;
begin
  if (TMenuItem(sender).caption = 'Alt+F4') and
    (Datawell.TableOptions.fieldbyname('AltF4ToClose').asboolean) then begin
    messagedlg('Alt-F4 is being used to close the program',mtinformation,[mbok],0);
    exit;
  end;
  if TMenuItem(sender).caption = 'Alt+F6' then exit;
  CheckSave;
  UpdateButtons;
  GridMacro.hide;
  didfind:=false;
  with Datawell.TableMacros do begin
    first;
    while not EOF do begin
      if TMenuItem(sender).caption = Datawell.TableMacros.fieldbyname('Macro').asstring then begin
        didfind:=true;
        break;
      end;
      next;
    end;
  end;
  GridMacro.show;
  DSMacrosDataChange(Sender,nil);
  Script.setfocus;
  TimerPointer.enabled:=true;
end;

procedure TFormMacros.GridMacroKeyPress(Sender: TObject; var Key: Char);
begin
  if key = #13 then begin
    key:=#0;
    GridMacroDblClick(Sender);
  end;
end;

procedure TFormMacros.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  Status.caption:=' '+(sender as TControl).hint;
end;

procedure TFormMacros.BtnHelpClick(Sender: TObject);
begin
  Datawell.Help('macros');
end;

procedure TFormMacros.FormShow(Sender: TObject);
var didfind: boolean;
begin
  with Datawell.TableMacros do begin
    didfind:=false;
    first;
    while not EOF do begin
      if Datawell.TableMacros.fieldbyname('Macro').asstring = Datawell.lastmacro then begin
        didfind:=true;
        break;
      end;
      next;
    end;
    if not didfind then first;
  end;
  UpdateLabels;
  UpdateButtons;
end;

procedure TFormMacros.UpdateLabels;
var
  logmac, linkmac, panmac, panmac2: string;
  i: integer;
begin
  logmac:=Datawell.TableOptions.fieldbyname('LoginMacro').asstring;
  linkmac:='';
  panmac:=Datawell.TableOptions.fieldbyname('PanicMacro').asstring;
  panmac2:=Datawell.TableOptions2.fieldbyname('PanicMacro2').asstring;
  LabelLogin.font.color:=clgray;
  LabelPanic.font.color:=clgray;
  LabelPanic2.font.color:=clgray;
  if logmac <> '' then begin
    LabelLogin.font.color:=clblue;
    for i:=0 to componentcount-1 do begin
      if TBitBtn(components[i]).hint = logmac then begin
        TBitBtn(components[i]).font.color:=clblue;
        TBitBtn(components[i]).font.style:=[fsbold];
        break;
      end;
    end;
    if panmac = logmac then LabelPanic.font.color:=clblue;
    if panmac2 = logmac then LabelPanic2.font.color:=clblue;
  end;
  if (linkmac <> '') and (linkmac <> logmac) then begin
    for i:=0 to componentcount-1 do begin
      if TBitBtn(components[i]).hint = linkmac then begin
        TBitBtn(components[i]).font.color:=clfuchsia;
        TBitBtn(components[i]).font.style:=[fsbold];
        break;
      end;
    end;
    if panmac = linkmac then LabelPanic.font.color:=clfuchsia;
    if panmac2 = linkmac then LabelPanic2.font.color:=clfuchsia;
  end;
  if (panmac <> '') and (panmac <> logmac) and (panmac <> linkmac) then begin
    LabelPanic.font.color:=clgreen;
    for i:=0 to componentcount-1 do begin
      if TBitBtn(components[i]).hint = panmac then begin
        TBitBtn(components[i]).font.color:=clgreen;
        TBitBtn(components[i]).font.style:=[fsbold];
        break;
      end;
    end;
    if panmac2 = panmac then LabelPanic2.font.color:=clgreen;
  end;
  if (panmac2 <> '') and (panmac2 <> logmac) and (panmac2 <> linkmac)
    and (panmac2 <> panmac) then begin
    LabelPanic2.font.color:=clred;
    for i:=0 to componentcount-1 do begin
      if TBitBtn(components[i]).hint = panmac2 then begin
        TBitBtn(components[i]).font.color:=clred;
        TBitBtn(components[i]).font.style:=[fsbold];
        break;
      end;
    end;
  end;
end;

procedure TFormMacros.GridMacroCalcCellColors(Sender: TObject;
  Field: TField; State: TGridDrawState; highlight: Boolean; AFont: TFont;
  ABrush: TBrush);
var
  isspecial: boolean;
  logmac, linkmac, panmac, panmac2: string;
  coms: TStringList;
begin
  logmac:=Datawell.TableOptions.fieldbyname('LoginMacro').asstring;
  linkmac:='';
  panmac:=Datawell.TableOptions.fieldbyname('PanicMacro').asstring;
  panmac2:=Datawell.TableOptions2.fieldbyname('PanicMacro2').asstring;
  if field.value = 'Alt+F4' then begin
    if Datawell.TableOptions.fieldbyname('AltF4ToClose').asboolean then begin
      afont.color:=clsilver;
      afont.style:=[fsitalic];
      abrush.color:=clgray;
      exit;
    end;
  end;
  if field.value = 'Alt+F6' then begin
    afont.color:=clsilver;
    afont.style:=[fsitalic];
    abrush.color:=clgray;
    exit;
  end;
  if field.value = 'F7' then begin
    afont.color:=clsilver;
    afont.style:=[fsitalic];
    abrush.color:=clgray;
    exit;
  end;
  if field.value = 'Shift+F7' then begin
    afont.color:=clsilver;
    afont.style:=[fsitalic];
    abrush.color:=clgray;
    exit;
  end;
  isspecial:=false;
  if field.value = logmac then begin
    afont.color:=clblue;
    afont.style:=[fsbold];
    isspecial:=true;
  end;
  if (field.value = linkmac) and (linkmac <> logmac) then begin
    afont.color:=clfuchsia;
    afont.style:=[fsbold];
    isspecial:=true;
  end;
  if (field.value = panmac) and (panmac <> logmac) and (panmac <> linkmac) then begin
    afont.color:=clgreen;
    afont.style:=[fsbold];
    isspecial:=true;
  end;
  if (field.value = panmac2) and (panmac2 <> logmac) and (panmac2 <> linkmac)
    and (panmac2 <> panmac) then begin
    afont.color:=clred;
    afont.style:=[fsbold];
    isspecial:=true;
  end;
  if not isspecial then begin
    coms:=TStringList.create;
    coms.assign(Datawell.TableMacros.fieldbyname('Script'));
    if coms.count > 0 then begin
      afont.color:=clwhite;
      afont.style:=[fsbold];
      isspecial:=true;
    end;
    coms.free;
  end;
  if isspecial then begin
    if highlight then abrush.color:=clgray else abrush.color:=clsilver;
  end;
end;

procedure TFormMacros.UpdateButtons;
var
  i: integer;
  hin, logmac, linkmac, panmac, panmac2: string;
begin
  logmac:=Datawell.TableOptions.fieldbyname('LoginMacro').asstring;
  linkmac:='';
  panmac:=Datawell.TableOptions.fieldbyname('PanicMacro').asstring;
  panmac2:=Datawell.TableOptions2.fieldbyname('PanicMacro2').asstring;
  for i:=0 to componentcount-1 do begin
    if TComponent(components[i]).tag <> 1 then continue;
    if TComponent(components[i]).tag > 900 then continue;
    hin:=TBitBtn(components[i]).hint;
    if hin = 'F1' then continue;
    if (hin = 'Alt+F4') and (Datawell.TableOptions.fieldbyname('AltF4ToClose').asboolean) then continue;
    if hin = 'Alt+F6' then continue;
    if hin = logmac then continue;
    if hin = linkmac then continue;
    if hin = panmac then continue;
    if hin = panmac2 then continue;
    if CountCommands(hin) > 0 then begin
      TBitBtn(components[i]).font.style:=[fsbold];
      TBitBtn(components[i]).font.color:=clwhite;
    end
    else begin
      TBitBtn(components[i]).font.style:=[];
      TBitBtn(components[i]).font.color:=clblack;
    end;
  end;
end;

procedure TFormMacros.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key = VK_DELETE then begin
    if activecontrol = GridMacro then begin
      BtnClear.click;
      key:=0;
    end;
  end;
end;

procedure TFormMacros.UpdatePointer;
var p, h1, h2: integer;
begin
  p:=1;
  if GridMacro.canvas.pixels[5,28] = clblack then p:=1
  else if GridMacro.canvas.pixels[5,46] = clblack then p:=2
  else if GridMacro.canvas.pixels[5,64] = clblack then p:=3
  else if GridMacro.canvas.pixels[5,82] = clblack then p:=4
  else if GridMacro.canvas.pixels[5,100] = clblack then p:=5
  else if GridMacro.canvas.pixels[5,118] = clblack then p:=6
  else if GridMacro.canvas.pixels[5,136] = clblack then p:=7;
  ImagePointer.canvas.pen.color:=clblack;
  ImagePointer.canvas.brush.color:=clbtnface;
  ImagePointer.canvas.pen.width:=1;
  ImagePointer.canvas.polygon([point(-5,-5),point(25,-5),
    point(25,175),point(-5,175),point(-5,-5)]);
  //draw arrow base
  h1:=11+(18*p);
  ImagePointer.canvas.moveto(0,h1);
  ImagePointer.canvas.lineto(5,h1);
  //draw arrow tip
  h2:=5;
  ImagePointer.canvas.moveto(11,h2);
  ImagePointer.canvas.lineto(20,h2);
  ImagePointer.canvas.moveto(14,h2-3);
  ImagePointer.canvas.lineto(19,h2);
  ImagePointer.canvas.moveto(14,h2+3);
  ImagePointer.canvas.lineto(19,h2);
  //draw arrow body
  ImagePointer.canvas.moveto(5,h1);
  ImagePointer.canvas.lineto(11,h2);
end;

procedure TFormMacros.TimerPointerTimer(Sender: TObject);
begin
  UpdatePointer;
  TimerPointer.enabled:=false;
end;

procedure TFormMacros.BtnLoginClick(Sender: TObject);
var mac: string;
begin
  mac:=Datawell.TableMacros.fieldbyname('Macro').asstring;
  if mac = 'Alt+F4' then begin
    if Datawell.TableOptions.fieldbyname('AltF4ToClose').asboolean then begin
      messagedlg('Alt-F4 is being used to close the program',mtinformation,[mbok],0);
      exit;
    end;
  end;
  if mac = 'Alt+F6' then begin
    messagedlg('Alt-F6 Cannot be used as a macro',mtinformation,[mbok],0);
    exit;
  end;
  case TComponent(sender).tag of
    901: begin
         Datawell.TableOptions.edit;
         Datawell.TableOptions.fieldbyname('LoginMacro').asstring:=mac;
         Datawell.TableOptions.post;
       end;
    902: begin
         Datawell.TableOptions.edit;
         Datawell.TableOptions.fieldbyname('PanicMacro').asstring:=mac;
         Datawell.TableOptions.post;
       end;
    903: begin
         Datawell.TableOptions2.edit;
         Datawell.TableOptions2.fieldbyname('PanicMacro2').asstring:=mac;
         Datawell.TableOptions2.post;
       end;
  end;
  GridMacro.repaint;
  UpdateLabels;
  UpdateButtons;
end;

procedure TFormMacros.BtnClearLoginClick(Sender: TObject);
begin
  case TComponent(sender).tag of
    901: begin
         Datawell.TableOptions.edit;
         Datawell.TableOptions.fieldbyname('LoginMacro').asstring:='';
         Datawell.TableOptions.post;
       end;
    902: begin
         Datawell.TableOptions.edit;
         Datawell.TableOptions.fieldbyname('PanicMacro').asstring:='';
         Datawell.TableOptions.post;
       end;
    903: begin
         Datawell.TableOptions2.edit;
         Datawell.TableOptions2.fieldbyname('PanicMacro2').asstring:='';
         Datawell.TableOptions2.post;
       end;
  end;
  GridMacro.repaint;
  UpdateLabels;
  UpdateButtons;
end;

procedure TFormMacros.BtnDoneClick(Sender: TObject);
begin
  CheckSave;
  Datawell.lastmacro:=Datawell.TableMacros.fieldbyname('Macro').asstring;
  close;
end;

procedure TFormMacros.CheckSave;
var
  i: integer;
  didfail: boolean;
begin
  didfail:=false;
  with Datawell.TableMacros do begin
    if fieldbyname('Macro').asstring <> '' then begin
      for i:=0 to Script.lines.count-1 do begin
        if Script.lines[i] = fieldbyname('Macro').asstring then begin
          didfail:=true;
          break;
        end;
      end;
      if didfail then begin
        messagedlg('A macro calling itself would cause recurstion',mtinformation,[mbok],0);
        abort;
      end;
      bypass:=true;
      edit;
      fieldbyname('Script').assign(Script.lines);
      post;
      bypass:=false;
      BtnUndo.enabled:=false;
    end;
    refresh;
  end;
end;

procedure TFormMacros.DSMacrosDataChange(Sender: TObject; Field: TField);
begin
  if not GridMacro.visible then exit;
  if bypass then exit;
  Script.lines.assign(Datawell.TableMacros.fieldbyname('Script'));
  if (Datawell.TableMacros.fieldbyname('Macro').asstring = 'Alt+F6') or
     ((Datawell.TableMacros.fieldbyname('Macro').asstring = 'Alt+F4') and
      (Datawell.TableOptions.fieldbyname('AltF4ToClose').asboolean)) then begin
    Script.readonly:=true;
    Script.color:=clsilver;
  end
  else begin
    Script.readonly:=false;
    Script.color:=clwindow;
  end;
  BtnUndo.enabled:=false;
  TimerPointer.enabled:=true;
end;

procedure TFormMacros.BtnUndoClick(Sender: TObject);
begin
  DSMacrosDataChange(Sender,nil);
  Script.setfocus;
end;

procedure TFormMacros.BtnFunctionsClick(Sender: TObject);
var
  form: TFormFunctions;
  i, l, po: integer;
begin
  form:=TFormFunctions.create(self);
  form.Setup(Datawell.lastfunction,Script.seltext);
  form.showmodal;
  po:=form.po;
  form.free;
  i:=Script.selstart;
  l:=Script.sellength;
  if po < 1 then begin
    Script.setfocus;
    exit;
  end;
  Script.pastefromclipboard;
  Script.setfocus;
  Script.sellength:=0;
  Script.selstart:=i+po;
end;

procedure TFormMacros.BtnVarClick(Sender: TObject);
var
  formv: TFormVarGrab;
  grab: string;
  i, l: integer;
begin
  formv:=TFormVarGrab.create(self);
  formv.setup;
  formv.showmodal;
  grab:=formv.grab;
  formv.free;
  i:=Script.selstart;
  l:=Script.sellength;
  if grab = '' then begin
    Script.setfocus;
    Script.selstart:=i;
    Script.sellength:=l;
    exit;
  end;
  EditCopy.text:=grab;
  EditCopy.selectall;
  EditCopy.copytoclipboard;
  Script.pastefromclipboard;
  Script.setfocus;
  Script.sellength:=0;
  Script.selstart:=i+length(EditCopy.text);
end;

procedure TFormMacros.BtnClearClick(Sender: TObject);
begin
  if Script.lines.count < 1 then exit;
  Script.lines.clear;
  BtnUndo.enabled:=true;
  Script.setfocus;
end;

procedure TFormMacros.ScriptChange(Sender: TObject);
begin
  LabelLines.caption:='Commands = '+inttostr(Script.lines.count);
  BtnUndo.enabled:=true;
end;

procedure TFormMacros.FormCreate(Sender: TObject);
begin
  bypass:=false;
end;

procedure TFormMacros.GridMacroEnter(Sender: TObject);
begin
  CheckSave;
  UpdateButtons;
end;

function TFormMacros.CountCommands(mac: string): integer;
var
  coms: TStringList;
  table: TwwTable;
begin
  result:=0;
  table:=TwwTable.create(self);
  with table do begin
    databasename:=Datawell.bde;
    tablename:='Macros.db';
    wwfilter.assign(Datawell.TableMacros.wwfilter);
    filterActivate;
    active:=true;
    first;
    while not EOF do begin
      if fieldbyname('Macro').asstring = mac then begin
        coms:=TStringList.create;
        coms.assign(fieldbyname('Script'));
        result:=coms.count;
        coms.free;
        break;
      end;
      next;
    end;
  end;
  table.free;
end;

procedure TFormMacros.BtnAMClick(Sender: TObject);
var
  form: TFormAM;
  grab: string;
  i, l: integer;
begin
  form:=TFormAM.create(self);
  form.avoid:=Datawell.TableMacros.fieldbyname('Macro').asstring;
  form.setup;
  form.showmodal;
  grab:=form.am;
  form.free;
  i:=Script.selstart;
  l:=Script.sellength;
  if grab = '' then begin
    Script.setfocus;
    Script.selstart:=i;
    Script.sellength:=l;
    exit;
  end;
  EditCopy.text:=grab;
  EditCopy.selectall;
  EditCopy.copytoclipboard;
  Script.pastefromclipboard;
  Script.setfocus;
  Script.sellength:=0;
  Script.selstart:=i+length(EditCopy.text);
end;

end.

