unit NewConnection;

interface

uses
  Database,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TFormNewConnection = class(TForm)
    BtnOK: TBitBtn;
    BtnCancel: TBitBtn;
    EditHost: TEdit;
    EditPort: TEdit;
    Label10: TLabel;
    Label9: TLabel;
    CheckCR: TCheckBox;
    BtnMud: TBitBtn;
    procedure BtnCancelClick(Sender: TObject);
    procedure BtnOKClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure EditHostKeyPress(Sender: TObject; var Key: Char);
    procedure EditPortKeyPress(Sender: TObject; var Key: Char);
    procedure EditHostChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    linked: boolean;
  end;

var
  FormNewConnection: TFormNewConnection;

implementation

{$R *.DFM}

procedure TFormNewConnection.FormCreate(Sender: TObject);
begin
  linked:=false;
end;

procedure TFormNewConnection.BtnCancelClick(Sender: TObject);
begin
  close;
end;

procedure TFormNewConnection.EditHostKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = #13 then begin
    EditPort.setfocus;
    key:=#0;
  end;
end;

procedure TFormNewConnection.EditPortKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = #13 then begin
    BtnOK.click;
    key:=#0;
  end;
end;

procedure TFormNewConnection.BtnOKClick(Sender: TObject);
begin
  linked:=true;
  close;
end;

procedure TFormNewConnection.EditHostChange(Sender: TObject);
begin
  if (length(EditHost.text) > 0) and (length(EditPort.text) > 0) then BtnOK.enabled:=true
  else BtnOK.enabled:=false;
end;

end.
