unit Note;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ColorGrd, ExtCtrls, Menus, ad3ThesaurusBase,
  ad3Thesaurus, ad3SpellBase, ad3Spell;

type
  TFormNote = class(TForm)
    BtnAutoscribble: TBitBtn;
    BtnCancel: TBitBtn;
    Editor1: TMemo;
    Spell: TAddictSpell3;
    Thesaurus: TThesaurus3;
    MainMenu: TMainMenu;
    MenuAutotyperHelp: TMenuItem;
    MenuInvisible: TMenuItem;
    Escape: TMenuItem;
    MenuExit2: TMenuItem;
    Spelling1: TMenuItem;
    Thesaurus1: TMenuItem;
    Autotype1: TMenuItem;
    DialogSave: TSaveDialog;
    DialogOpen: TOpenDialog;
    AutoScribble: TMenuItem;
    BtnSpellcheck: TBitBtn;
    BtnThesaurus: TBitBtn;
    procedure BtnAutoscribbleClick(Sender: TObject);
    procedure BtnCancelClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Spelling1Click(Sender: TObject);
    procedure Editor1Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    doat: boolean;
  end;

var
  FormNote: TFormNote;

implementation

uses Database;

{$R *.DFM}

procedure TFormNote.FormCreate(Sender: TObject);
begin
  doat:=false;
end;

procedure TFormNote.BtnAutoscribbleClick(Sender: TObject);
begin
  doat:=true;
  close;
end;

procedure TFormNote.BtnCancelClick(Sender: TObject);
begin
  close;
end;

procedure TFormNote.Spelling1Click(Sender: TObject);
begin
  if not Datawell.CheckRinged(false,'Autoscribble spellcheck/thesaurus') then exit;
  case TComponent(sender).tag of
    1: Spell.CheckWinControl(Editor1,ctAll);
    2: Thesaurus.LookupWinControl(Editor1);
  end;
end;

procedure TFormNote.Editor1Change(Sender: TObject);
begin
  BtnAutoscribble.enabled:=Editor1.text <> '';
end;

end.
