unit SetCoordinates;

interface

uses
  Database,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, ColorGrd, Mask, Wwdbedit, Wwdbspin, Wwtable;

type
  TFormSetCoordinates = class(TForm)
    BtnOK: TBitBtn;
    BtnCancel: TBitBtn;
    Label8: TLabel;
    Label12: TLabel;
    EditX: TwwDBSpinEdit;
    EditY: TwwDBSpinEdit;
    Label1: TLabel;
    EditMap: TComboBox;
    procedure BtnCancelClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BtnOKClick(Sender: TObject);
    procedure EditXExit(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    start: boolean;
  end;

var
  FormSetCoordinates: TFormSetCoordinates;

implementation

{$R *.DFM}

procedure TFormSetCoordinates.FormCreate(Sender: TObject);
var table: TwwTable;
begin
  start:=false;
  table:=TwwTable.create(self);
  with table do begin
    databasename:=Datawell.bde;
    tablename:='Maps.db';
    active:=true;
    first;
    while not EOF do begin
      EditMap.items.add(fieldbyname('Map').asstring);
      next;
    end;
  end;
  table.free;
  if EditMap.items.count > 0 then EditMap.itemindex:=0;
end;

procedure TFormSetCoordinates.BtnCancelClick(Sender: TObject);
begin
  close;
end;

procedure TFormSetCoordinates.BtnOKClick(Sender: TObject);
begin
  start:=true;
  close;
end;

procedure TFormSetCoordinates.EditXExit(Sender: TObject);
begin
  if TwwDBSpinEdit(sender).value < -9999 then TwwDBSpinEdit(sender).value:=-9999;
  if TwwDBSpinEdit(sender).value > 9999 then TwwDBSpinEdit(sender).value:=9999;
end;

end.

