unit EnterRegister;

interface

uses
  Database,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mask, Buttons, ExtCtrls;

type
  TFormEnterRegister = class(TForm)
    BtnOK: TBitBtn;
    BtnCancel: TBitBtn;
    EditPIN: TEdit;
    Label1: TLabel;
    MemoWarning: TMemo;
    Label2: TLabel;
    EditCode: TEdit;
    Label3: TLabel;
    Bevel1: TBevel;
    Label4: TLabel;
    BtnRegister: TBitBtn;
    Bevel2: TBevel;
    procedure BtnCancelClick(Sender: TObject);
    procedure EditCodeChange(Sender: TObject);
    procedure EditCodeKeyPress(Sender: TObject; var Key: Char);
    procedure EditPINKeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure BtnRegisterClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    RefreshRegistry, notfromabout: boolean;
  end;

var
  FormEnterRegister: TFormEnterRegister;

implementation

{$R *.DFM}

procedure TFormEnterRegister.FormCreate(Sender: TObject);
begin
  RefreshRegistry:=false;
  notfromabout:=false;
end;

procedure TFormEnterRegister.BtnCancelClick(Sender: TObject);
begin
  close;
end;

procedure TFormEnterRegister.EditCodeChange(Sender: TObject);
begin
  if (length(EditPIN.text) > 0) and (length(EditCode.text) > 0) then
    BtnOK.enabled:=true
  else BtnOK.enabled:=false;
end;

procedure TFormEnterRegister.EditCodeKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = #13 then begin
    EditPIN.selectall;
    EditPIN.setfocus;
    key:=#0;
  end;
end;

procedure TFormEnterRegister.EditPINKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = #13 then begin
    BtnOK.click;
    key:=#0;
  end;
end;

procedure TFormEnterRegister.BtnRegisterClick(Sender: TObject);
begin
  Datawell.EXE('http://www.'+Datawell.homesite+
    '.com/reframe.php?target=cgi-bin/ga_pages.pl?register','','c:\',SW_SHOW);
end;

end.



